function [S,T,Y] = admmLasso(W, Sinit, Tinit, Yinit, X, hiddenSize, visibleSize, beta, maxIter, rho)

W = reshape(W, visibleSize, hiddenSize);

if ~exist('rho', 'var')
    rho = 0.01;
end

if ~exist('maxIter', 'var')
    maxIter = 30;
end

S = Sinit;
T = Tinit;
Y = Yinit;

% Invert the matrix 
M = inv(W'*W + rho*eye(size(W,2)));
S1 = M * W' * X;

% Run ADMM solver
for iter = 1:maxIter
    S = S1 + M * (rho*T - Y);
    T = softThreshold(S + Y/rho, beta/rho);
    Y = Y + rho*(S - T);
    
    % Output Stats
    fprintf('\t%d\t', iter);
%     fprintf('\t%f', 0.5 * sum(sum((W*S - X).^2)) + beta * sum(sum(abs(S))));
    fprintf('\n');
end

end