function [cost, grad] = basesLoss(theta, S, X, hiddenSize, visibleSize, constCost)

if ~exist('constCost', 'var')
    constCost = 0;
end

oW = reshape(theta, visibleSize, hiddenSize);
W = l2col(oW);

cost = 0.5 * sum(sum((W*S - X).^2)) + constCost;
Wgrad = (W*S - X) * S';

Wgrad = l2colg(oW, W, Wgrad);
grad = Wgrad(:);

end