hiddenSize = 4;
visibleSize = 3;
beta = 0.5;

data = randn(visibleSize, 5);
X = data;
W = randn(size(data, 1), hiddenSize);
S = randn(hiddenSize, size(data, 2));

[cost, grad] = basesLoss(W(:), S, X, hiddenSize, visibleSize);
numgrad = computeNumericalGradient( @(W)basesLoss(W, S, X, hiddenSize, visibleSize), W(:));

disp([numgrad grad]); 
diff = norm(numgrad-grad)/norm(numgrad+grad);
disp(diff);

[cost, grad] = sparseCodesLoss(S(:), W, X, hiddenSize, visibleSize, beta);
numgrad = computeNumericalGradient( @(S) sparseCodesLoss(S, W, X, hiddenSize, visibleSize, beta), S(:));

disp([numgrad grad]); 
diff = norm(numgrad-grad)/norm(numgrad+grad);
disp(diff);

