function [grad] = l2colg(x,y,outderv)

    global normeps;
    if isempty(normeps)
        normeps = 1e-8;
    end
	if (~exist('outderv','var')||isempty(outderv))
		error('Requires outderv of previous layer to compute gradient!');
	end
     
	epssumsq = sum(x.^2,1) + normeps;	

	l2cols = sqrt(epssumsq);

    if (~exist('y','var')||isempty(y))
         y = bsxfun(@rdivide,x,l2cols);
    end
	grad = bsxfun(@rdivide, outderv, l2cols) - ...
           bsxfun(@times, y, sum(outderv.*x, 1) ./ epssumsq);

end
