function [cost, grad] = sparseCodesLoss(S, W, X, hiddenSize, visibleSize, beta)

W = reshape(W, visibleSize, hiddenSize);
S = reshape(S, hiddenSize, numel(S)/hiddenSize);

absS = sqrt(S.^2 + 1e-5);

cost = 0.5 * sum(sum((W*S - X).^2)) + beta * sum(sum(absS));

Sgrad = W' * (W*S - X) + beta * S ./ absS;

grad = Sgrad(:);

end