%% Addpath
addpath ../minFunc/
addpath ../minConf/
addpath ../minConf/minConf/
addpath ../minConf/minFunc/
addpath ../sparseAE/soln/

%% Load Data
load /afs/cs/group/brain/scratch5/vanHateren/raw16x16_SPLITtrain2var.mat
sel = randperm(size(data, 2));
data = data(:, sel(1:20000));

%% Whiten
% Remove DC
data = bsxfun(@minus, data, mean(data, 1));
data = data / std(data(:));

% Remove the "mean" patch
data = bsxfun(@minus, data, mean(data, 2));

cov = data * data' / size(data, 2);
[E,D] = eig(cov);
d = diag(D);

% Sort descending
[dsort, idx] = sort(d, 'descend');

% PCA Whitening + Dimension Reduction Pick top 99%
dsum = cumsum(dsort);
dcutoff = find(dsum > 0.99 * dsum(end), 1);
E = E(:, idx(1:dcutoff));
d = d(idx(1:dcutoff));
V = E * diag(1./sqrt(d+0.1)) * E';

% ZCA Whitening
% V = E * diag(1./sqrt(d+1e-6)) * E';

%% Whiten
Vi = pinv(V);
whiteData = V * data;

%% Initialize S and B
hiddenSize = 200;
visibleSize = size(whiteData, 1);
beta = 0.5;

W = l2col(randn(size(whiteData, 1), hiddenSize));
S = zeros(hiddenSize, size(whiteData, 2));

options.Method = 'lbfgs';
options.maxIter = 30;
options.display = 'on';

T = S;
Y = 0;

%%
for iter = 1:100
    
    % Optimize S
    %     [S] = minFunc( @sparseCodesLoss, S(:), options, W, whiteData, ...
    %                          hiddenSize, visibleSize, beta);
    [S,T,Y] = admmLasso(W, S, T, Y, whiteData, hiddenSize, visibleSize, beta, 100, 0.1);
    S = reshape(S, hiddenSize, size(whiteData, 2));
    
    % Optimize B
    %     W = randn(size(W));
    %     [W] = minConf_PQN( @(W) basesLoss(W,  S, whiteData, hiddenSize, visibleSize, beta * sum(sum(abs(S)))), ...
    %         W(:), @(W) basesConstraint(W, 1), options);
    [W] = minFunc( @(W) basesLoss(W,  S, whiteData, hiddenSize, visibleSize, beta * sum(sum(abs(S)))), ...
        W(:), options);
	W = reshape(W, visibleSize, hiddenSize);
    W = l2col(W);
    
    % Display
    display_network(Vi*W);
    
end

