function [cost, grad, pred] = softmaxCost(theta, outputSize, inputSize, lambda, data, labels)
%softmaxCost 

% WARNING: Large chunks copied from sparseAutoencoderCost!

W2 = reshape(theta(1:outputSize*inputSize), outputSize, inputSize);
temp = outputSize * inputSize;
b2 = theta(temp+1:temp+outputSize);

M = size(data, 2);
outputMatrix = full(sparse(labels, 1:M, 1));
cost = 0;

h = data;

z3 = bsxfun(@plus, W2*h, b2);
z3 = bsxfun(@minus, z3, max(z3,[],1)); % Rescale
e3 = exp(z3);

loss = 0;
zTerm = (z3 .* outputMatrix);
zTerm = sum(zTerm(:));
loss = loss + ( zTerm - sum(log(sum(e3, 1))) );
loss = loss / M;

pred = bsxfun(@rdivide, e3, sum(e3, 1));
deriv = outputMatrix - pred;

% Maximise the log-likelihood = minimise the negative of the log-likelihood
loss = -loss;
deriv = -deriv;

cost = cost + loss;
cost = cost + (lambda / 2) * sum(sum(W2.^2));
outderv = deriv / M;

W2grad = outderv * h';
W2grad = W2grad + lambda * W2;
b2grad = sum(outderv, 2);

grad = [W2grad(:); b2grad(:)];

end

