function theta = stackedInitializeParameters(sizeVector)

numLayers = size(sizeVector, 1);
W = cell(numLayers, 1);
b = cell(numLayers, 1);
numElems = 0;

for i = 1:numLayers-1
    % We'll choose weights uniformly from the interval [-r, r]
    r  = 0.100;
    W{i} = rand(sizeVector(i+1), sizeVector(i)) * 2 * r - r;
    b{i} = zeros(sizeVector(i+1), 1);
    numElems = numElems + numel(W{i}) + numel(b{i});
end

theta = stackedRollIntoTheta(sizeVector, W, b);

end

