function [] = stackedRollCheck()
%stackedRollCheck Check if stackedRollIntoTheta and stackedRollOutOfTheta
%are working correctly

disp('Running stackedRollCheck');

sizeVector = [13; 17; 23; 29; 37];

WCheck = cell(4);
bCheck = cell(4);
for i = 1:4
    WCheck{i} = rand(sizeVector(i+1), sizeVector(i));
    bCheck{i} = rand(sizeVector(i+1), 1);
end

theta = stackedRollIntoTheta(sizeVector, WCheck, bCheck);
[numLayers, WRet, bRet] = stackedRollOutOfTheta(sizeVector, theta);

assert(numLayers == size(sizeVector, 1), 'Incorrect number of layers');

for i = 1:4
    assert(isequal(WRet{i}, WCheck{i}), sprintf('Weight %d unrolled incorrectly', i));
    assert(isequal(bRet{i}, bCheck{i}), sprintf('Bias %d unrolled incorrectly', i));
end

disp('stackedRollCheck passed');

end

