function [theta, version] = stackedRollIntoTheta(sizeVector, W, b)
%stackedRollIntoTheta Roll cell arrays W, b into theta

assert(iscolumn(sizeVector), 'sizeVector should be a column vector');

numLayers = size(sizeVector, 1);
% W only from 1 to numLayers-1
% but b from 1 to numLayers
numElems = numel(b{numLayers});
for i = 1:numLayers-1
    numElems = numElems + numel(W{i}) + numel(b{i});
end

theta = zeros(numElems, 1);

temp = 1;
for i = 1:numLayers
    theta(temp:temp + numel(W{i}) - 1 ) = W{i};
    temp = temp + numel(W{i});
    theta(temp:temp + numel(b{i}) - 1 ) = b{i};
    temp = temp + numel(b{i});    
end

version = [2 0 0];

end

