function [numLayers, W, b] = stackedRollOutOfTheta(sizeVector, theta)
%stackedRollOutOfTheta Unroll vector theta to give cell arrays W, b

assert(iscolumn(sizeVector), 'sizeVector should be a column vector');

numLayers = size(sizeVector, 1);
W = cell(numLayers, 1);
b = cell(numLayers, 1);

temp = 1;
for i = 1:numLayers-1   
    W{i} = reshape(theta(temp:temp + sizeVector(i+1) * sizeVector(i) - 1), sizeVector(i+1), sizeVector(i) );
    temp = temp + sizeVector(i) * sizeVector(i+1);
    b{i} = theta(temp:temp + sizeVector(i+1) - 1);
    temp = temp + sizeVector(i+1);    
end

end

