function [ell, deriv, pred] = visualisationClassifierCost(incoming, weights, outputMatrix)
global Z_VCWHICH;

%visualisationClassifierCost
%   incoming - vector of incoming values 
%              (incoming(k,i) = theta_k x^(i) for all k (i.e. all classes))
%   weights - matrix containing thetas, such that weights(r, c) = theta_r, c
%   outputMatrix - otuputMatrix(r,c) = 1 if y(c) = r; 0 otherwise
%
%   ell   - mean log-likelihood (not negated, stackedAutoencoderCost negates it)
%   deriv - matrix of mean derivatives of log-likelihood wrt thetas
%   pred  - matrix of predictions

M = size(outputMatrix, 2);

which = Z_VCWHICH; % which neuron to visualise
ell = sum(sigmoid(incoming(which, :))) / M;
deriv = zeros(size(incoming));
deriv(which, :) = sigmoid(incoming(which, :)) .* (1 - sigmoid(incoming(which, :)));
deriv = deriv / M;

pred = zeros(size(incoming));

end

